unit UnitRasAPI32;
//Unit permettant d'accder  des fonctions de la dll RASAPI32.DLL
// pour d'autres fonctions contenues dans la dll RASAPI32, allez voir sur
// le site de Piette http://www.rtfm.be/fpiette.

interface

uses Windows;

const
  UNLEN = 256;
  PWLEN = 256;
  DNLEN = 15;
  RAS_MaxEntryName      =  256;
  RAS_MaxDeviceName     =  128;
  RAS_MaxDeviceType     =  16;
  RAS_MaxPhoneNumber    =  128;
  RAS_MaxCallbackNumber =  RAS_MaxPhoneNumber;

type
  HRASConn = DWORD;

  PRASConn = ^TRASConn;
  TRASConn = record
     dwSize: DWORD;
     rasConn: HRASConn;     // handle de la connexion
     szEntryName: Array[0..RAS_MaxEntryName] of Char;
     szDeviceType : Array[0..RAS_MaxDeviceType] of Char;
     szDeviceName : array [0..RAS_MaxDeviceName] of char;
  end;

  PRASConnStatus = ^TRASConnStatus;
  TRASConnStatus = record
    dwSize: LongInt;
    rasConnstate: Word;
    dwError: LongInt;
    szDeviceType: Array[0..RAS_MaxDeviceType] of Char;
    szDeviceName: Array[0..RAS_MaxDeviceName] of Char;
  end;

  PRASDialParams = ^TRASDialParams;
  TRASDialParams = record 
    dwSize: DWORD;
    szEntryName     : Array[0..RAS_MaxEntryName] of Char;
    szPhoneNumber   : Array[0..RAS_MaxPhoneNumber] of Char;
    szCallbackNumber: Array[0..RAS_MaxCallbackNumber] of Char;
    szUserName      : Array[0..UNLEN] of Char;
    szPassword      : Array[0..PWLEN] of Char;
    szDomain        : Array[0..DNLEN] of Char;
  end;

  PRASDIALEXTENSIONS= ^TRASDIALEXTENSIONS;
  TRASDIALEXTENSIONS= record
    dwSize: DWORD;
    dwfOptions: DWORD;
    hwndParent: HWnd;
    reserved: DWORD;
  end;



// entte des fonctions que l'on souhaite utiliser et qui seront issu de la
// dll RASAPI32.dll

function RasEnumConnections(RASConn: PrasConn;            { buffer recevant les donnes }
                            var BufSize: DWord;           { taille du buffer }
                            var Connections: DWord        { nombre de connexions }
                            ): LongInt; stdcall;
function RasHangUp(RASConn: hrasConn): LongInt; stdcall;  { handle de la connection  dconnecter }

function RasGetConnectStatus(RASConn: hrasConn;           { handle de la connexion  examiner}
                             RASConnStatus: PRASConnStatus{ buffer recevant les donnes }
                             ): LongInt; stdcall;
 
function RasDial(
    lpRasDialExtensions : PRASDIALEXTENSIONS ;// pointer to function extensions data
    lpszPhonebook   : PChar;          // pointer to full path and filename of phone-book file
    lpRasDialParams : PRASDIALPARAMS; // pointer to calling parameters data
    dwNotifierType  : DWORD;          // specifies type of RasDial event handler
    lpvNotifier     : DWORD;          // specifies a handler for RasDial events
    var rasConn     : HRASConn        // Handle de la connexion
   ): DWORD; stdcall;

function RasGetErrorString(ErrorCode: DWord;      // valeur (DWord) de l'erreur dont on veut conaitre le
                                                  // message d'erreur associ
                           szErrorString: PChar;  // buffer contenant le message d'erreur
                           BufSize: DWord         // taille du buffer
                           ): LongInt; stdcall;

implementation

function RasEnumConnections;  external 'RASAPI32.DLL' name 'RasEnumConnectionsA';
function RasHangUp;           external 'RASAPI32.DLL' name 'RasHangUpA';
function RasGetConnectStatus; external 'RASAPI32.DLL' name 'RasGetConnectStatusA';
function RasDial;             external 'RASAPI32.DLL' name 'RasDialA';
function RasGetErrorString;   external 'RASAPI32.DLL' name 'RasGetErrorStringA';

end.
